package com.steerinfo.dil.controller;

import com.steerinfo.dil.model.WmshInboundResult;
import com.steerinfo.dil.service.impl.WmshGridMaterialServiceImpl;
import com.steerinfo.dil.service.impl.WmshInboundResultServiceImpl;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * WmshInboundResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-10 11:08
 * 类描述
 * 修订历史：
 * 日期：2021-10-10
 * 作者：generator
 * 参考：
 * 描述：WmshInboundResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/wmshinboundresults")
public class WmshInboundResultController extends BaseRESTfulController {

    @Autowired
    WmshInboundResultServiceImpl wmshInboundResultService;

    @Autowired
    WmshGridMaterialServiceImpl wmshGridMaterialService;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="新增港存库入库实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "wmshInboundResult", value = "入库实绩", required = false, dataType = "WmshInboundResult"),
    })
    @PostMapping("/addWarehousingResult")
    public RESTfulResult addWarehousingResult(@RequestBody(required = false) WmshInboundResult wmshInboundResult){
        int i1 = wmshInboundResultService.addWarehousingResult(wmshInboundResult);
        BigDecimal batchId = wmshInboundResult.getBatchId();
        BigDecimal portId = wmshInboundResult.getPortId();
        BigDecimal resultMaterialNumber = wmshInboundResult.getResultMaterialNumber();
        BigDecimal status = new BigDecimal(1);
        Map<String,Object> map = new HashMap<>();
        map.put("batchId",batchId);
        map.put("portId",portId);
        map.put("resultTonnage",resultMaterialNumber);
        map.put("status",status);
        int i2 = wmshGridMaterialService.updatePortStock(map);
        return success(i1 + i2);
    }

    @ApiOperation(value="查询所有港存库入库实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(157)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getInBoundResult")
    public RESTfulResult getInBoundResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                      Integer apiId,
                                      Integer pageNum,
                                      Integer pageSize
    ){
        //不分页筛选数据
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> result = wmshInboundResultService.getAllResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null,result);
        return success(pageList);
    }

    @ApiOperation(value="通过实绩Id查询实绩")
    @PostMapping("/getResultById/{resultId}")
    public RESTfulResult getResultById(@PathVariable("resultId") Integer resultId){
        List<Map<String, Object>> resultById = wmshInboundResultService.getResultById(resultId);
        return success(resultById);
    }

    @ApiOperation(value="修改港存库入库实绩")
    @PostMapping("/updateWareHosingResult")
    public RESTfulResult updateWareHosingResult(@RequestBody(required = false) WmshInboundResult wmshInboundResult){
        int i = wmshInboundResultService.updateWareHosingResult(wmshInboundResult);
        return success(i);
    }

    @ApiOperation(value="逻辑删除港存库入库实绩")
    @PostMapping("/deleteWareHosingResult/{resultId}")
    public RESTfulResult deleteWareHosingResult(@PathVariable("resultId")Integer resultId){
        int i = wmshInboundResultService.deleteWareHosingResult(resultId);
        return success(i);
    }
}
